;	BSTUB.ASM	demonstrates segment controls needed
;			to link MASM code to large case C88 with -B -M option.

;			Called with hello();.

;	notes: if you wish to start with an assembler module, there
;	       must be a public entry point of MAIN in the PROG segment. This
;	       is the starting point.

;              To access data in a C program, remember that all scalors
;              and "static" data is in DGROUP and the offset operator
;              must include DGROUP:. Accessing global arrays or structures
;              or routines is no problem- just declare them extrn.

;              Remember that
;              ZIP   PROC   FAR
;              ZIP   ENDS
;              lines are needed around every procedure so that call
;              and return are long call and long return.

;              The GROUP statement and the DATA and UDATA SEGMENT
;              declarations should be exactly as described. Any
;              other names can be used for program segments or
;              additional data segments.


DGROUP	GROUP	DATA,UDATA

	EXTRN	PUTS:FAR

STUB_PROG	SEGMENT BYTE PUBLIC 'PROG'
	ASSUME	CS:STUB_PROG,DS:DGROUP

	PUBLIC	HELLO			;NOTE: ALTHOUGH C88 USES A TRAILING
					;UNDERSCORE ON PUBLICS, THESE ARE
					;DELETED IN .OBJ FORMAT.

HELLO	PROC	FAR
	MOV	AX,OFFSET DGROUP:HELLO_MSG ;DATA IN DGROUP
	PUSH	DS
	PUSH	AX
	CALL	PUTS
	ADD	SP,4
	MOV	AX,SEG HELLO_AGAIN
	PUSH	AX
	MOV	AX,OFFSET HELLO_AGAIN
	PUSH	AX
	CALL	PUTS
	ADD	SP,4
	RET
HELLO	ENDP
STUB_PROG	ENDS


;	WITH LARGE CASE C88, SEVERAL SEGMENTS ARE USED FOR DATA.
;	SCALORS AND STATICS GO INTO THE DATA AND UDATA SEGMENTS WHICH
;	ARE COMBINED TOGETHER WITH A GROUP STATEMENT AND ARE
;	ALWAYS ADDRESSED RELATIVE TO DS DURING EXECUTION. THE
;	UNINITILIZED SCALORS AND STATICS GO INTO UDATA SO THEY
;	CAN BE ZEROED OUT BY THE START-UP CODE.

DATA	SEGMENT	WORD PUBLIC 'DATA'
J		DW	1		;EQUIVALENT TO int j=1;
HELLO_MSG	DB	'Hello World!!',10,0	;EQUIVALENT TO
					; static hello_msg[]="Hello World!!\n";
DATA	ENDS

UDATA	SEGMENT	WORD PUBLIC 'DATA'
I	DW	1 DUP (?)		;EQUIVALENT TO int i;
UDATA	ENDS				;THE DUP (?) IS NEEDED TO AVOID
					;INITILIZATION



;	ESEG IS THE CLASS OF SEGMENTS FOR INITILIZED NON 'STATIC' ARRAYS AND
;	STRUCTURES. THE SEGMENT NAME DOESNT MATTER BUT THE CLASS DOES.

BSTUB_ESEG	SEGMENT WORD 'ESEG'
HELLO_AGAIN	DB	'Hello Again!!',10,0	;EQUIVALENT TO
					; char hello_again[]="Hello Again!!\n";
BSTUB_ESEG	ENDS



;	NON-STATIC UNINITILIZED ARRAYS AND STRUCTURES EACH GO INTO
;	THEIR OWN SEGMENT. THE CLASS NAME MUST BE DATA BUT YOU CAN
;	USE ANY SEGMENT NAMES YOU WISH. VARIABLES MUST BE DECLARED
;	AS	nnn DUP (?) TO PREVENT THE .EXE FILE FROM GROWING LARGE.
;	THESE SEGMENTS ARE ZEROED AT RUN TIME.

BUFFER_DATA	SEGMENT	WORD 'DATA'
BUFFER	DB	100 DUP (?)		; EQUIVALENT TO char buffer[100];
					; NOTE: only variables in UDATA
					; are zeroed at run time.
BUFFER_DATA	ENDS

	END
